
// Compile with:
// gcc -o pdf-test -framework Foundation -framework Quartz
//                 -framework Cocoa pdf-test.m
//

#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>

@interface myThread:NSThread {
	int flag;
	PDFDocument *p1, *p2;
	PDFView *v1, *v2;
}
@end

@implementation myThread:NSThread

- (void)quit { flag = 1; }
- (void)setp1 { [v1 setDocument: p1]; }
- (void)setp2 { [v1 setDocument: p2]; }

// Main event driver
- (void)main {
	
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSString *s1 = @"http://www.flownet.com/ron/test.pdf";
	NSString *s2 = @"http://www.flownet.com/ron/specials.pdf";
	
	p1 = [[PDFDocument alloc] initWithURL: [[NSURL alloc] initWithString: s1]];
	v1 = [[PDFView alloc] init];
	NSWindow *w1 = [[NSWindow alloc] initWithContentRect:
					NSMakeRect(0, 0, 400, 600)
											   styleMask:15
												 backing:NSBackingStoreBuffered
												   defer:YES];
        [w1 setTitle: @"W1"];
        [w1 setReleasedWhenClosed: NO];
        [w1 center];
        [w1 orderFront: nil];
	[w1 setContentView: v1];


	p2 = [[PDFDocument alloc] initWithURL: [[NSURL alloc] initWithString: s2]];
	v2 = [[PDFView alloc] init];

	NSWindow *w2 = [[NSWindow alloc] initWithContentRect:
					NSMakeRect(0, 0, 400, 600)
											   styleMask:15
												 backing:NSBackingStoreBuffered
												   defer:YES];
        [w2 setTitle: @"W2"];
        [w2 setReleasedWhenClosed: NO];
        [w2 center];
        [w2 orderFront: nil];
	[w2 setContentView: v2];

	flag = 0;
	
	[v1 setDocument: p1];
        [v2 setDocument: p2];
	
	
	
	
	while (!flag) {
          sleep(3);
          [v1 setDocument: nil];
          [v2 setDocument: nil];
          [v1 setDocument: p1];
          [v2 setDocument: p2];
          sleep(3);
          [v1 setDocument: nil];
          [v2 setDocument: nil];
          [v1 setDocument: p2];
          [v2 setDocument: p1];
          
	}
	
	[NSApp terminate:self];
	[pool release];
}

@end


int main( int argc, const char* argv[])
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	[NSApplication sharedApplication];
	
	// Start the event driver thread
	[[[myThread alloc] init] start];
	
	[NSApp run];
	
	// This code never seems to run.  Do I really need it?  Or am I doing
	// something wrong when I terminate the app?
	NSLog(@"Exiting");
	[pool release];
	return 0;
}

